NanoEngineer: open-source nanotech CAD
==============================

NanoEngineer-1 is an open-source molecular modeling and simulation system that looks and feels like SolidWorks. It features an easy-to-use interactive 3D graphical user interface for designing and modeling large, atomically precise composite systems like molecular machines, DNA, carbon nanotubes, peptide chains, machine elements, etc.

For simulation and analysis, NanoEngineer-1 supports multiple molecular dynamics and quantum mechanics systems in a single environment, providing a wide range of nano-scale simulation capabilities. The following molecular dynamics and quantum chemistry packages are supported:

 * [GROMACS](http://www.gromacs.org/gromacs/features/feature-summary.html)
 * [GAMESS](http://www.msg.ameslab.gov/GAMESS/)
 * [PC GAMESS](http://classic.chem.msu.su/gran/gamess/)
 * [Massively Parallel Quantum Chemistry (MPQC) Program](http://www.mpqc.org/)

### Contents

1\.    [Gallery](#gallery)

1.1\.    [Molecular machines](#molecularmachines)

1.2\.    [Carbon nanotubes](#carbonnanotubes)

1.3\.    [Structural DNA nanotechnology](#dnananotech)

1.4\.    [Molecular manufacturing](#molecularmanufacturing)

1.5\.    [About these images](#abouttheseimages)

2\.    [Helpful links and installing](#helpfullinks)

3\.    [Installing from source](#installing)

4\.    [Video](#video)

Developer/user group: http://groups.google.com/group/nanoengineer-dev

<a name="gallery" />

1\. Gallery
------------

<a name="molecularmachines" />

### 1.1\. Molecular machines

<a href="http://nanoengineer-1.com/content/index.php?option=com_content&task=view&id=52&Itemid=62"><img title="MarkIII(k) Planetary Gear" src="http://nanoengineer-1.com/content/images/stories/gallery/assemblies/gears/mark-iiik/a8/a8_qm_animation5.gif" /></a>
<a href="http://nanoengineer-1.com/content/index.php?option=com_content&task=view&id=46&Itemid=56"><img title="SRG-Ic (parallel-shaft speed reducer gear)" src="http://nanoengineer-1.com/content/images/stories/gallery/assemblies/gears/srg-i/a8/a8_qm_animation5.gif" /></a>
<a href="http://nanoengineer-1.com/content/index.php?option=com_content&task=view&id=51&Itemid=61"><img title="SRG-II" src="http://nanoengineer-1.com/content/images/stories/gallery/assemblies/gears/srg-ii/a8/a8_pov_small_animation2.gif" /></a>
<a href="http://nanoengineer-1.com/content/index.php?option=com_content&task=view&id=42&Itemid=52"><img title="SRG-III" src="http://nanoengineer-1.com/content/images/stories/gallery/assemblies/gears/srg-iii/a8/a8_pov_animation2.gif" /></a>
<a href="http://nanoengineer-1.com/content/index.php?option=com_content&task=view&id=44&Itemid=54"><img title="Drexler-Merkle Differential Gear" src="http://nanoengineer-1.com/content/images/stories/gallery/assemblies/gears/diff%20gear/a8/a8_pov_animation2.gif" /></a>
<a href="http://nanoengineer-1.com/content/index.php?option=com_content&task=view&id=45&Itemid=55"><img title="Neon Pump" src="http://nanoengineer-1.com/content/images/stories/gallery/assemblies/pumps/neon%20pump/a8_qm_neonpump1.gif" /></a>
<a href="http://nanoengineer-1.com/content/index.php?option=com_content&task=view&id=47&Itemid=57"><img title="Small Bearing" src="http://nanoengineer-1.com/content/images/stories/gallery/assemblies/bearings/small%20bearing/a8/pov_animation2.gif" /></a>
<a href="http://nanoengineer-1.com/content/index.php?option=com_content&task=view&id=48&Itemid=58"><img title="Strained-shell Sleeve Bearing (Nanosystems p.296)" src="http://nanoengineer-1.com/content/images/stories/gallery/assemblies/bearings/large%20bearing/a8/pov_animation1.gif" /></a>
<a href="http://nanoengineer-1.com/content/index.php?option=com_content&task=view&id=41&Itemid=51"><img title="Universal Joint" src="http://nanoengineer-1.com/content/images/stories/gallery/assemblies/couplings/universal%20joint/a8/a8_animation3.gif" /></a>
<a href="http://nanoengineer-1.com/content/index.php?option=com_content&task=view&id=43&Itemid=53"><img title="electrostatic potential of a cytosine molecule" src="http://nanoengineer-1.com/content/images/stories/gallery/assemblies/bearings/small%20bearing/a8/esp/esp_ne1_animations/smallbearing_cpk_esp7.gif" /></a>

<a href="http://www.nanoengineer-1.net/mediawiki/index.php?title=Worm_Drive"><img title="Worm Drive" src="http://www.nanoengineer-1.net/mediawiki/images/5/54/WormGearAnimation1.gif" /></a>

<a href="http://www.nanoengineer-1.net/mediawiki/index.php?title=Sorting_Pump"><img title="Sorting Pump" src="http://www.nanoengineer-1.net/mediawiki/images/1/10/SortingPump1.png" /></a>

<a href="http://www.nanoengineer-1.net/mediawiki/index.php?title=Universal_Joint"><img title="Universal Joint" src="http://www.nanoengineer-1.net/mediawiki/images/3/3c/A8_ujoint_motors2.png" /></a>

<a name="carbonnanotubes" />

### 1.2\. Carbon nanotubes

<a href="http://nanoengineer-1.com/content/index.php?option=com_content&task=view&id=38&Itemid=48">
<img title="Low-friction Carbon Nanotube Bearing Assembly" src="http://nanoengineer-1.com/content/images/stories/gallery/cnt/ringrod_16mer_1.png" />
<img title="Carbon Nanotube Molecular Bearing Assembly" src="http://nanoengineer-1.com/content/images/stories/gallery/cnt/14x22dwcntsimspinwheelcut_2.png" />
<img title="Carbon Nanotube Crimp Junction" src="http://nanoengineer-1.com/content/images/stories/gallery/cnt/cnt_crimpjunc1.png" />
<img title="Carbon Nanotube 6-way Junction" src="http://nanoengineer-1.com/content/images/stories/gallery/cnt/nanotube_octahedron_si_hinges1.png" />
</a>

<a name="dnananotech" />

### 1.3\. Structural DNA nanotechnology

<a href="http://nanoengineer-1.com/content/index.php?option=com_content&task=view&id=37&Itemid=47">
<img title="DNA origami" src="http://nanoengineer-1.com/content/images/stories/gallery/sdn/dna_origami3_256.png" />
<img title="DNA tetrahedron" src="http://nanoengineer-1.com/content/images/stories/gallery/sdn/dna_tetrahedron1_256.png" />
<img title="DNA cube" src="http://nanoengineer-1.com/content/images/stories/gallery/sdn/dna_cube7.png" />
</a>

<a name="molecularmanufacturing" />

### 1.4\. Molecular manufacturing

<a href="http://nanoengineer-1.com/content/index.php?option=com_content&task=view&id=39&Itemid=49">
<img title="DC10c Carbon-transfer Tooltip" src="http://nanoengineer-1.com/content/images/stories/gallery/manufacturing/dc10c_holder1.png" />
<img title="Hydrogen Abstraction Tooltip" src="http://nanoengineer-1.com/content/images/stories/gallery/manufacturing/abstracter_1.png" />
<img title="Single-atom Deposition Tooltip" src="http://nanoengineer-1.com/content/images/stories/gallery/manufacturing/singleatom_assembly1.png" />
<img title="DC10c Carbon-transfer Tooltip in detail" src="http://nanoengineer-1.com/content/images/stories/gallery/manufacturing/dc10c_1.png" />
<img title="A potential C100GeATD defect structure" src="http://nanoengineer-1.com/content/images/stories/gallery/manufacturing/c100geatd.png" />
</a>

<a name="abouttheseimages" />

### 1.5\. About these images

More information about these images can be found [on the nanorex.com gallery](http://nanoengineer-1.com/content/index.php?option=com_content&task=view&id=36&Itemid=46).

Many of the images and animations in these galleries have been rendered with [QuteMol](http://qutemol.sourceforge.net/), a new open-source, interactive, high quality molecular visualization system which exploits the latest GPU capabilities through OpenGL shaders to offers an array of innovative visual effects. QuteMol was developed by [Marco Tarini](http://vcg.isti.cnr.it/~tarini) and [Paolo Cignoni](http://vcg.isti.cnr.it/~cignoni) of the [Visual Computing Lab](http://vcg.isti.cnr.it/) at [ISTI - CNR](http://www.isti.cnr.it/).

<a name="helpfullinks" />

2\. Helpful links and installing
------------

 * Nanorex http://nanorex.com/
 * mailing list http://groups.google.com/group/nanoengineer-dev
 * wiki http://nanoengineer-1.net/

In particular:

 * [Getting NE-1](http://www.nanoengineer-1.net/mediawiki/index.php?title=Get_NanoEngineer-1)
 * [Need help?](http://www.nanoengineer-1.net/mediawiki/index.php?title=Help)
 * [Documentation](http://www.nanoengineer-1.net/mediawiki/index.php?title=Category:Documentation) including manuals, tutorials, videos, API docs, etc.
 * [Getting involved](http://www.nanoengineer-1.net/mediawiki/index.php?title=Category:Contribute)

<a name="installing" />

3\. Installing from source
------------

Nanoengineer is a tricky beast to install. The [2008 release](http://www.nanoengineer-1.net/mediawiki/index.php?title=Get_NanoEngineer-1) will install and run on OS X and Windows. Compiling and running from source on Linux is the current ongoing project. To facilitate this effort, users can either create a chroot and install an older distribution of Ubuntu, or download a ready-made chroot. The development efforts are presently centered around upgrading dependencies in successive versions of modernized Ubuntu chroots, instead of trying to fix all problems simultaneously while running NanoEngineer on a modern GNU/Linux distribution.

To download and use the chroot:

```bash
# download the ready-made chroot archive
wget http://diyhpl.us/~bryan/irc/nanoengineer/nanoengineer-chroot.tar.gz

# extract the chroot
tar -zxvf nanoengineer-chroot.tar.gz

# jump in
sudo chroot nanoengineer-chroot/

# run nanoengineer
su nanoengineeruser -c "python ~/code/nanoengineer/cad/src/main.py"
```

Alternatively, you can follow [instructions to create a chroot](http://diyhpl.us/~bryan/irc/nanoengineer/nanoengineer-chroot-debootstrap). Developers can be reached on the [mailing list](http://groups.google.com/group/nanoengineer-dev) or on irc.freenode.net in the ##hplusroadmap channel.

<a name="video" />

4\. Nanofactory video
------------

http://www.youtube.com/watch?v=vEYN18d7gHg

The nanofactory animation was funded by a challenge grant. Read more [here](http://www.foresight.org/animation_challenge/index.html) (Foresight Institute). The original files are [here](http://www.foresight.org/nanofactory.mov) and [here](http://www.foresight.org/animation_challenge/nanofactory_360x240copyright_sor3.mov).
